

//******************************************************************//
//																	//
//				(C) 2017 R-MIK Sawomir Skrzyski					//
//				slawomir.skrzynski@ep.com.pl						//
//																	//
//	Programu nie mona rozpowszechnia bez pisemnej zgody autora!	//
//																	//
//******************************************************************//


#include <rmik/fcpu.h>


#ifndef FCPU_TPOM
  #define	FCPU_TPOM	281.0
#endif

#ifndef DEFPOMCLK
  #define DEFPOMCLK	0x6b696d52	// Tekst "Rmik"
#endif

#ifndef FCPU_KOR
  #define FCPU_KOR	4
#endif


//=======================================================================//
//----- Oszacowanie czstotliwoci mikrokontrolera
// Funkcja jako pierwsza w kodzie (za main).
// W innych miejscach moe dziaa niepoprawnie lub niepotrzebnie wyduyc start programu
// (pomiar musi wywoac zadziaanie WDG.
//----------------------------------------------------------------------//
long fcpuCalculate()
{
long fcpu;


	if ( PomiarFCLK != DEFPOMCLK )	// Jeli pomiar nie by wykonany
		{
		PomiarFCLK = DEFPOMCLK;
		f_us = 0;
		cli();						// Koniecze jeli funkcja wywoania po wczeniu IRQ
		wdt_enable( WDTO_30MS );	// Ustawienie WDG (IRQ musz byc wyczone)
		wdt_reset();				// Koniecze jeli funkcja wywoania gdy WDG by ju w uyciu lub wczony bit WDTON w fuses
		while( true )
			{
			f_us++;					// Zmienn zwikszamy co 1ms do czasu a WDG zrestartuje mikrokontroler
			_delay_us(100);
			}
		}
	else							// Pomiar zakoczony, interpretuj wynik
		{
		// FCPU_TPOM - czas pomiaru WDTO_30MS (uwagi w pliku ".h"
		// DCPU_KOR  - korekta liczniaka, uwagi j.w.
		fcpu = F_CPU * (f_us-FCPU_KOR) / FCPU_TPOM;
		// Procentowa odchyka czstotliwoci
		fcpuDeviation = ((long)fcpu * 100 / (F_CPU)) - 100 ;
		}


return( fcpu );
}


//=======================================================================//
